
difficulty normal

#recipe give @a[tag=!recipes_removed] *
#advancement grant @a[tag=!recipes_removed] only minecraft:adventure/shoot_arrow
#advancement grant @a[tag=!recipes_removed] only minecraft:adventure/ol_betsy
#tag @a[tag=!recipes_removed] add recipes_removed

execute if score in_progress game_state matches 1.. run tag @a[team=!lobby,team=!editor,nbt=!{Inventory:[{Slot:22b}]}] add leave_game
tp @a[tag=leave_game] 0 100 0 0 0
stopsound @a[tag=leave_game]
execute as @a[tag=leave_game] at @s run playsound minecraft:entity.player.levelup master @s ~ ~1 ~ 0.3 1.8
tag @a[tag=leave_game] add disconnect
tag @a[tag=leave_game] remove leave_game

# Disconnect Detection

tag @a[team=!lobby,team=!editor,team=!spectator,team=!pvp,team=!trident,team=!crystal,team=!red,team=!blue] add disconnect
tag @a[scores={disconnect=1..}] add disconnect

execute unless score game_running game_state matches 1 run team leave @a[tag=disconnect]
execute unless score game_running game_state matches 1 run scoreboard players reset @a[tag=disconnect]
team leave @a[tag=disconnect,team=spectator]
scoreboard players reset @a[tag=disconnect,team=!red,team=!blue,team=!pvp]
team join lobby @a[team=,tag=disconnect]
scoreboard players set @a[tag=disconnect] death 1
tag @a[tag=disconnect,tag=spectating] remove spectating
tag @a[tag=disconnect,tag=winner] remove winner
tag @a[tag=disconnect,tag=leading] remove leading
tag @a[tag=disconnect,tag=respawn] remove respawn
tag @a[tag=disconnect,tag=ghost] remove ghost
tag @a[tag=disconnect] remove ready
xp set @a[tag=disconnect] 0 levels
xp set @a[tag=disconnect] 0 points
effect give @a[tag=disconnect] instant_health 1 4 true
spawnpoint @a[tag=disconnect] 0 100 0 0
tag @a[tag=disconnect] remove disconnect


# ID Handler

execute as @a unless score @s player_id matches 1.. run tag @s add needs_player_id
execute if entity @a[tag=needs_player_id] run function bow_game:assign_player_id
tag @e[type=snowball,tag=!registered] add needs_entity_id
tag @e[type=potion,tag=!registered] add needs_entity_id

execute as @e[type=ender_pearl,tag=!no_owner] at @s run summon ender_pearl ~ ~ ~ {Tags:["no_owner"]}
execute as @e[type=ender_pearl,tag=!no_owner] at @s as @e[type=ender_pearl,tag=no_owner,sort=nearest,limit=1] run data modify entity @s Motion set from entity @e[type=ender_pearl,tag=!no_owner,sort=nearest,limit=1] Motion
kill @e[type=ender_pearl,tag=!no_owner]
tag @e[type=ender_pearl,tag=!registered] add needs_entity_id
execute if entity @e[tag=needs_entity_id] run function bow_game:assign_entity_id



# Team counter

scoreboard players operation players_previous count = players count
scoreboard players set players count 0
scoreboard players set ready count 0
scoreboard players set red count 0
scoreboard players set blue count 0
execute as @a[tag=!ghost] unless entity @s[team=!blue,team=!red,team=!pvp,team=!crystal,team=!trident] run scoreboard players add players count 1
execute as @a[tag=ready] unless entity @s[team=!blue,team=!red,team=!pvp,team=!crystal,team=!trident] run scoreboard players add ready count 1
execute as @a[team=red] run scoreboard players add red count 1
execute as @a[team=blue] run scoreboard players add blue count 1




# Death Announcement System

execute if entity @a[scores={death=1..},team=!lobby,team=!editor,team=!spectator] if entity @a[scores={kill_player=1..},team=!lobby,team=!editor,team=!spectator] run tellraw @a[team=!lobby,team=!editor] {"text":"[","color":"gray","extra":[{"selector":"@a[scores={kill_player=1..},team=!lobby,team=!spectator,team=!editor]"},{"text":" → ","color":"gold"},{"selector":"@a[scores={death=1..},team=!lobby,team=!spectator,team=!editor]"},{"text":"]"}]}
execute if entity @a[scores={death_explosion=1..},team=!lobby,team=!editor,team=!spectator] as @e[type=marker,tag=detonate] at @s as @a if score @s player_id = @e[type=marker,tag=detonate,sort=nearest,limit=1] player_id run tellraw @a[team=!lobby,team=!editor] {"text":"[","color":"gray","extra":[{"selector":"@s"},{"text":" ☀ ","color":"gold"},{"selector":"@a[scores={death_explosion=1..},team=!lobby,team=!spectator,team=!editor]"},{"text":"]"}]}
execute as @a[scores={death=1..},team=!lobby,team=!editor,team=!spectator] unless score @s death_explosion matches 1.. unless entity @a[scores={kill_player=1..},team=!lobby,team=!editor,team=!spectator] run tellraw @a[team=!lobby,team=!editor] {"text":"[","color":"gray","extra":[{"text":"☠ ","color":"gold"},{"selector":"@s"},{"text":"]"}]}

execute as @a[scores={death_explosion=1..},team=!red,team=!blue] at @s as @e[type=marker,tag=detonate] unless score @s player_id = @p player_id at @s as @a[team=!red,team=!blue] if score @s player_id = @e[type=marker,tag=detonate,sort=nearest,limit=1] player_id run scoreboard players add @s kill_player 1
execute as @a[scores={death_explosion=1..},team=blue] at @s as @e[type=marker,tag=detonate] unless score @s player_id = @p player_id at @s as @a[team=red] if score @s player_id = @e[type=marker,tag=detonate,sort=nearest,limit=1] player_id run scoreboard players add @s kill_player 1
execute as @a[scores={death_explosion=1..},team=red] at @s as @e[type=marker,tag=detonate] unless score @s player_id = @p player_id at @s as @a[team=blue] if score @s player_id = @e[type=marker,tag=detonate,sort=nearest,limit=1] player_id run scoreboard players add @s kill_player 1

effect clear @a[scores={death=1..}]



# Map Update

execute if score map game_state matches 0 run function bow_game:map_update/battlefield
execute if score map game_state matches 1 run function bow_game:map_update/canyon
execute if score map game_state matches 2 run function bow_game:map_update/mushroom_valley
execute if score map game_state matches 3 run function bow_game:map_update/woodworks
execute if score map game_state matches 4 run function bow_game:map_update/coastline
execute if score map game_state matches 5 run function bow_game:map_update/ice_palace
execute if score map game_state matches 6 run function bow_game:map_update/crypt
execute if score map game_state matches 7 run function bow_game:map_update/canvas
execute if score map game_state matches 8 run function bow_game:map_update/beehive


# Gamemode Update

execute if score gamemode game_state matches 0 run function bow_game:gamemode_update/team_deathmatch
execute if score gamemode game_state matches 1 run function bow_game:gamemode_update/capture_the_flag
execute if score gamemode game_state matches 2 run function bow_game:gamemode_update/resurrection
execute if score gamemode game_state matches 3 run function bow_game:gamemode_update/deathmatch
execute if score gamemode game_state matches 4 run function bow_game:gamemode_update/crystal_keepers
execute if score gamemode game_state matches 5 run function bow_game:gamemode_update/curse_of_the_trident


# Game running loop

execute unless score in_progress game_state matches 0 run function bow_game:game_update


# Death Reset

execute as @a[scores={kill_player=1..}] run scoreboard players operation @s kill_streak += @s kill_player
execute as @a[scores={kill_player=1..}] run scoreboard players operation @s kills_this_round += @s kill_player
execute as @a[scores={kill_player=1..}] at @s run playsound minecraft:entity.experience_orb.pickup master @s ~ ~1 ~ 0.25 0.75
scoreboard players reset @a[scores={kill_player=1..}] kill_player

execute unless score in_progress game_state matches 1.. run scoreboard players reset @a[scores={kill_streak=1..}] kill_streak
execute if score gamemode game_state matches 5 run scoreboard players reset @a[scores={kill_streak=1..}] kill_streak
execute if score kill_streak game_state matches 1.. unless score gamemode game_state matches 5 as @a[scores={kill_streak=1..}] if score @s kill_streak >= kill_streak game_state run function bow_game:kill_streak_item



# Death Handler

effect give @a[scores={death=-3..}] resistance 3 4
clear @a[scores={death=1..}]
tag @a[scores={death=1..}] add not_menu_click
tp @a[team=lobby,scores={death=1..}] 0 100 0 0 0
scoreboard players reset @a[scores={death=1..,kill_streak=0..}] kill_streak
scoreboard players reset @a[scores={death=1..,equip_boots=-1000..}] equip_boots
xp set @a[scores={death=-3..}] 0 levels
xp set @a[scores={death=-3..}] 0 points
scoreboard players reset @a[scores={death=-1}] death
scoreboard players add @a[scores={death=..-2}] death 1
scoreboard players set @a[scores={death=1..}] death -3
execute if score gamemode game_state matches 0..1 run scoreboard players set @a[scores={death=-3..},team=red] respawn_camp_timer 500
execute if score gamemode game_state matches 0..1 run scoreboard players set @a[scores={death=-3..},team=blue] respawn_camp_timer 500
tag @a[scores={death=-3..},tag=out_of_spawn] remove out_of_spawn
scoreboard players reset @a[scores={death_explosion=1..}] death_explosion


# Special Items

execute if entity @e[type=snowball] run function bow_game:item_smoke_grenade
execute unless entity @e[type=snowball] if entity @e[type=marker,tag=smoke_tracker] run function bow_game:item_smoke_grenade

execute if entity @e[type=ender_pearl] run function bow_game:item_grenade
execute unless entity @e[type=ender_pearl] if entity @e[type=marker,tag=grenade_tracker] run function bow_game:item_grenade

execute if entity @e[type=marker,tag=land_mine] run function bow_game:item_land_mine
execute if entity @a[scores={shoot_crossbow=1..}] run function bow_game:item_crossbow
execute if entity @a[scores={equip_boots=-1000..}] run function bow_game:item_speed_boots


# Inventory Handler

clear @a[gamemode=!creative,nbt={Inventory:[{id:"minecraft:snow_block"}]}] minecraft:snow_block
clear @a[gamemode=!creative,nbt={Inventory:[{id:"minecraft:snow"}]}] minecraft:snow
execute if score in_progress game_state matches 0 run tag @a[nbt=!{Inventory:[{Slot:9b},{Slot:10b},{Slot:11b},{Slot:15b},{Slot:16b},{Slot:17b},{Slot:18b},{Slot:19b},{Slot:20b},{Slot:22b},{Slot:24b},{Slot:25b},{Slot:26b},{Slot:27b},{Slot:28b},{Slot:29b},{Slot:33b},{Slot:34b},{Slot:35b}]},gamemode=adventure,team=!editor] add inventory_update
tag @a[nbt=!{Inventory:[{Slot:9b},{Slot:10b},{Slot:11b},{Slot:15b},{Slot:16b},{Slot:17b},{Slot:18b},{Slot:19b},{Slot:20b},{Slot:22b},{Slot:24b},{Slot:25b},{Slot:26b},{Slot:27b},{Slot:28b},{Slot:29b},{Slot:33b},{Slot:34b},{Slot:35b}]},gamemode=adventure,team=lobby] add inventory_update
execute if score in_progress game_state matches 0 as @a[nbt=!{Inventory:[{Slot:13b}]}] unless entity @s[team=!red,team=!blue,team=!pvp] run tag @s add inventory_update
execute if entity @a[tag=inventory_update] run function bow_game:lobby_inventory_update


execute as @a[nbt=!{Inventory:[{Slot:103b,tag:{TeamColor:1b}}]}] unless entity @s[team=!red,team=!blue,team=!pvp,team=!trident] run clear @s leather_helmet{TeamColor:1b}
execute as @a[nbt=!{Inventory:[{Slot:103b,tag:{TeamColor:1b}}]}] if entity @s[team=crystal] run clear @s end_crystal{TeamColor:1b}

clear @a[nbt={Inventory:[{Slot:103b,id:"minecraft:leather_helmet",tag:{TeamColor:1b}}]},team=crystal] leather_helmet{TeamColor:1b}
clear @a[nbt={Inventory:[{Slot:103b,id:"minecraft:end_crystal",tag:{TeamColor:1b}}]},team=!crystal] end_crystal{TeamColor:1b}
clear @a[nbt={Inventory:[{Slot:103b,id:"minecraft:leather_helmet",tag:{TeamColor:1b}}]},tag=has_flag,team=red] leather_helmet{TeamColor:1b}
clear @a[nbt={Inventory:[{Slot:103b,id:"minecraft:red_banner",tag:{TeamColor:1b}}]},tag=!has_flag] red_banner{TeamColor:1b}
clear @a[nbt={Inventory:[{Slot:103b,id:"minecraft:leather_helmet",tag:{TeamColor:1b}}]},tag=has_flag,team=blue] leather_helmet{TeamColor:1b}
clear @a[nbt={Inventory:[{Slot:103b,id:"minecraft:blue_banner",tag:{TeamColor:1b}}]},tag=!has_flag] blue_banner{TeamColor:1b}

clear @a[nbt={Inventory:[{id:"minecraft:leather_helmet",tag:{TeamColor:1b}}]},team=!red,team=!blue,team=!pvp,team=!trident] leather_helmet{TeamColor:1b}

item replace entity @a[nbt=!{Inventory:[{Slot:103b,tag:{TeamColor:1b}}]},team=red,tag=!has_flag,nbt=!{ActiveEffects:[{Id:14}]}] armor.head with leather_helmet{AttributeModifiers:[],TeamColor:1b,HideFlags:68,display:{Name:'{"text":"Red Team","color":"red","italic":"false"}',color:16719647},Unbreakable:1}
item replace entity @a[nbt=!{Inventory:[{Slot:103b,tag:{TeamColor:1b}}]},team=blue,tag=!has_flag,nbt=!{ActiveEffects:[{Id:14}]}] armor.head with leather_helmet{AttributeModifiers:[],TeamColor:1b,HideFlags:68,display:{Name:'{"text":"Blue Team","color":"blue","italic":"false"}',color:5201919},Unbreakable:1}
item replace entity @a[nbt=!{Inventory:[{Slot:103b,tag:{TeamColor:1b}}]},team=blue,tag=has_flag,nbt=!{ActiveEffects:[{Id:14}]}] armor.head with red_banner{AttributeModifiers:[{AttributeName:"generic.movement_speed",Amount:-0.15,Slot:head,Operation:1,Name:"generic.movement_speed",UUID:[I;-122328,28493,22836,-56986]}],HideFlags:2,TeamColor:1b,BlockEntityTag:{Patterns:[{Pattern:"gru",Color:6}]},HideFlags:32,display:{Name:'{"text":"Red Team Flag","color":"red","italic":"false"}'}}
item replace entity @a[nbt=!{Inventory:[{Slot:103b,tag:{TeamColor:1b}}]},team=red,tag=has_flag,nbt=!{ActiveEffects:[{Id:14}]}] armor.head with blue_banner{AttributeModifiers:[{AttributeName:"generic.movement_speed",Amount:-0.15,Slot:head,Operation:1,Name:"generic.movement_speed",UUID:[I;-122328,28493,22836,-56986]}],HideFlags:2,TeamColor:1b,BlockEntityTag:{Patterns:[{Pattern:"gru",Color:3}]},HideFlags:32,display:{Name:'{"text":"Blue Team Flag","color":"blue","italic":"false"}'}}
item replace entity @a[nbt=!{Inventory:[{Slot:103b,tag:{TeamColor:1b}}]},team=pvp,nbt=!{ActiveEffects:[{Id:14}]}] armor.head with leather_helmet{AttributeModifiers:[],TeamColor:1b,HideFlags:68,display:{Name:'{"text":"Players Team","color":"yellow","italic":"false"}',color:15722255},Unbreakable:1}
item replace entity @a[nbt=!{Inventory:[{Slot:103b,tag:{TeamColor:1b}}]},team=trident,nbt=!{ActiveEffects:[{Id:14}]}] armor.head with leather_helmet{AttributeModifiers:[{AttributeName:"generic.movement_speed",Amount:-0.4,Slot:head,Operation:1,Name:"generic.movement_speed",UUID:[I;-122328,28493,22836,-56986]}],TeamColor:1b,HideFlags:70,display:{Name:'{"text":"Players Team","color":"aqua","italic":"false"}',color:1048575},Unbreakable:1}
item replace entity @a[nbt=!{Inventory:[{Slot:103b,tag:{TeamColor:1b}}]},team=crystal,nbt=!{ActiveEffects:[{Id:14}]}] armor.head with end_crystal{AttributeModifiers:[{AttributeName:"generic.movement_speed",Amount:-0.15,Slot:head,Operation:1,Name:"generic.movement_speed",UUID:[I;-122328,28493,22836,-56986]}],HideFlags:2,TeamColor:1b,display:{Name:'{"text":"End Crystal","color":"light_purple","italic":"false"}'}}


execute as @a[nbt=!{Inventory:[{Slot:102b,tag:{TeamColor:1b}}]}] unless entity @s[team=!red,team=!blue,team=!pvp,team=!trident,team=!crystal] run clear @s leather_chestplate{TeamColor:1b}
clear @a[nbt={Inventory:[{id:"minecraft:leather_chestplate",tag:{TeamColor:1b}}]},team=!red,team=!blue,team=!pvp,team=!trident,team=!crystal] leather_chestplate{TeamColor:1b}
item replace entity @a[nbt=!{Inventory:[{Slot:102b,tag:{TeamColor:1b}}]},team=red,nbt=!{ActiveEffects:[{Id:14}]}] armor.chest with leather_chestplate{AttributeModifiers:[],TeamColor:1b,HideFlags:68,display:{Name:'{"text":"Red Team","color":"red","italic":"false"}',color:16719647},Unbreakable:1}
item replace entity @a[nbt=!{Inventory:[{Slot:102b,tag:{TeamColor:1b}}]},team=blue,nbt=!{ActiveEffects:[{Id:14}]}] armor.chest with leather_chestplate{AttributeModifiers:[],TeamColor:1b,HideFlags:68,display:{Name:'{"text":"Blue Team","color":"blue","italic":"false"}',color:5201919},Unbreakable:1}
item replace entity @a[nbt=!{Inventory:[{Slot:102b,tag:{TeamColor:1b}}]},team=pvp,nbt=!{ActiveEffects:[{Id:14}]}] armor.chest with leather_chestplate{AttributeModifiers:[],TeamColor:1b,HideFlags:68,display:{Name:'{"text":"Players Team","color":"yellow","italic":"false"}',color:15722255},Unbreakable:1}
item replace entity @a[nbt=!{Inventory:[{Slot:102b,tag:{TeamColor:1b}}]},team=trident,nbt=!{ActiveEffects:[{Id:14}]}] armor.chest with leather_chestplate{AttributeModifiers:[],TeamColor:1b,HideFlags:68,display:{Name:'{"text":"Players Team","color":"aqua","italic":"false"}',color:1048575},Unbreakable:1}
item replace entity @a[nbt=!{Inventory:[{Slot:102b,tag:{TeamColor:1b}}]},team=crystal,nbt=!{ActiveEffects:[{Id:14}]}] armor.chest with leather_chestplate{AttributeModifiers:[],TeamColor:1b,HideFlags:68,display:{Name:'{"text":"Players Team","color":"light_purple","italic":"false"}',color:16719871},Unbreakable:1}


# Basic Settings/Entity Handler

title @a[team=lobby] times 0 0 0
effect give @a saturation infinite 19 true
effect give @a[team=lobby] instant_health infinite 4 true
execute as @a run attribute @s minecraft:generic.attack_damage base set 0
effect give @a[team=!pvp,team=!red,team=!blue,team=!trident,team=!crystal] resistance infinite 4 true
execute if score in_progress game_state matches 0 run team leave @a[team=trident]
execute if score in_progress game_state matches 0 run team leave @a[team=crystal]
execute if score in_progress game_state matches 0 as @a unless entity @s[team=!pvp,team=!red,team=!blue,team=!trident,team=!crystal] run effect clear @s resistance
gamemode adventure @a[team=!spectator,team=!editor,tag=!ghost]
gamemode spectator @a[team=!spectator,team=!editor,tag=ghost]
execute if score in_progress game_state matches 0 run gamemode adventure @a[team=spectator]
kill @e[type=item,tag=!grenade,tag=!new_gamemode]
kill @e[type=minecraft:tnt]
scoreboard players set @a[nbt=!{HurtTime:0s}] regen_delay 200
scoreboard players remove @a[scores={health=..19}] regen_delay 1
effect clear @a regeneration
effect give @a[scores={regen_delay=..0}] regeneration 1 10 true
scoreboard players set @a[scores={regen_delay=..0}] regen_delay 100
tag @a[tag=has_flag,team=!red,team=!blue] remove has_flag

execute as @a[scores={throw_trident=1..}] at @s run playsound minecraft:item.trident.riptide_1 player @a ~ ~1 ~ 0.5 1.5
scoreboard players reset @a[scores={throw_trident=1..}] throw_trident



# Points Display

scoreboard players add points_display display_timer 1

execute if score players_previous count > players count run scoreboard objectives remove points_display
execute if score players_previous count > players count run scoreboard objectives add points_display dummy
execute if score points_display display_timer matches 100.. run scoreboard players set points_display display_timer 0
execute if score points_display display_timer matches 0..1 run scoreboard objectives modify points_display displayname {"text":"▷ ","bold":"true","color":"gold","extra":[{"text":"P","color":"white"},{"text":"OINTS","color":"green"},{"text":" ◁"}]}
execute if score points_display display_timer matches 2..3 run scoreboard objectives modify points_display displayname {"text":"▷ ","bold":"true","color":"gold","extra":[{"text":"P","color":"green"},{"text":"O","color":"white"},{"text":"INTS","color":"green"},{"text":" ◁"}]}
execute if score points_display display_timer matches 4..5 run scoreboard objectives modify points_display displayname {"text":"▷ ","bold":"true","color":"gold","extra":[{"text":"PO","color":"green"},{"text":"I","color":"white"},{"text":"NTS","color":"green"},{"text":" ◁"}]}
execute if score points_display display_timer matches 6..7 run scoreboard objectives modify points_display displayname {"text":"▷ ","bold":"true","color":"gold","extra":[{"text":"POI","color":"green"},{"text":"N","color":"white"},{"text":"TS","color":"green"},{"text":" ◁"}]}
execute if score points_display display_timer matches 8..9 run scoreboard objectives modify points_display displayname {"text":"▷ ","bold":"true","color":"gold","extra":[{"text":"POIN","color":"green"},{"text":"T","color":"white"},{"text":"S","color":"green"},{"text":" ◁"}]}
execute if score points_display display_timer matches 10..11 run scoreboard objectives modify points_display displayname {"text":"▷ ","bold":"true","color":"gold","extra":[{"text":"POINT","color":"green"},{"text":"S","color":"white"},{"text":" ◁"}]}
execute if score points_display display_timer matches 12.. run scoreboard objectives modify points_display displayname {"text":"▷ ","bold":"true","color":"gold","extra":[{"text":"POINTS","color":"green"},{"text":" ◁"}]}
scoreboard objectives setdisplay sidebar.team.white points_display
scoreboard objectives setdisplay sidebar.team.yellow points_display
scoreboard objectives setdisplay sidebar.team.red points_display
scoreboard objectives setdisplay sidebar.team.blue points_display
scoreboard objectives setdisplay sidebar.team.light_purple points_display

execute as @a[team=!lobby,team=!spectator,team=!editor,team=!red,team=!blue,scores={points=0..}] run scoreboard players operation @s points_modified = @s points
execute if score gamemode game_state matches 4 as @a[team=!lobby,team=!spectator,team=!editor,team=!red,team=!blue,scores={points=0..}] run scoreboard players operation @s points_modified /= ticks_per_second constants
execute as @a[team=!lobby,team=!spectator,team=!editor,team=!red,team=!blue,scores={points=0..}] run scoreboard players operation @s points_display = @s points_modified

execute if score Red points matches 0.. run scoreboard players operation Red points_display = Red points
execute if score Blue points matches 0.. run scoreboard players operation Blue points_display = Blue points



# Arrow Modifiers

execute as @a[scores={shoot_bow=1..},team=red] at @s positioned ~ ~1 ~ run tag @e[type=arrow,tag=!registered,tag=!red,tag=!blue,distance=..5,sort=nearest,limit=1] add red
execute as @a[scores={shoot_bow=1..},team=blue] at @s positioned ~ ~1 ~ run tag @e[type=arrow,tag=!registered,tag=!red,tag=!blue,distance=..5,sort=nearest,limit=1] add blue
scoreboard players reset @a[scores={shoot_bow=1..}] shoot_bow
execute as @e[type=arrow,tag=!registered,nbt=!{ShotFromCrossbow:1b}] run data merge entity @s {crit:0b,damage:7.8d}
tag @e[type=arrow,tag=!registered] add registered

execute as @e[type=arrow,tag=red] at @s run particle minecraft:dust 1 0.2 0.2 1 ~ ~.1 ~ 0 0 0 0 1 force
execute as @e[type=arrow,tag=blue] at @s run particle minecraft:dust 0.3 0.3 1 1 ~ ~.1 ~ 0 0 0 0 1 force
execute as @e[type=arrow,nbt={ShotFromCrossbow:1b}] at @s run particle minecraft:crit ~ ~.1 ~ 0 0 0 0.2 2 force
execute as @e[type=arrow,tag=!red,tag=!blue] at @s run particle minecraft:dust 1 0.9 0.2 1 ~ ~.1 ~ 0 0 0 0 1 force

execute as @e[type=arrow,nbt={inGround:1b}] at @s run particle minecraft:block minecraft:oak_planks ~ ~ ~ 0.2 0.2 0.2 0.1 10
execute as @e[type=arrow,nbt={inGround:1b}] at @s run playsound minecraft:entity.zombie.break_wooden_door neutral @a ~ ~ ~ 0.12 2
kill @e[type=arrow,nbt={inGround:1b}]



# Show game settings change text

tag @a[tag=op] remove settings_text
tellraw @a[tag=settings_text] {"text":"[","color":"yellow","extra":[{"text":"!","color":"gold"},{"text":"] To update game settings, you must be a server operator."},{"text":"\nPlease click ","color":"gray"},{"text":"[","bold":"true","color":"gold"},{"text":"here","bold":"true","color":"yellow","hoverEvent":{"action":"show_text","value":{"text":"Check Operator Status","color":"yellow"}},"clickEvent":{"action":"run_command","value":"/tag @s add enable_settings"}},{"text":"]","bold":"true","color":"gold"},{"text":" to enable changing settings.","color":"gray"}]}
execute as @a[tag=settings_text] at @s run playsound minecraft:block.note_block.bass master @s ~ ~1 ~ 0.5 1.5
tag @a[tag=settings_text] remove settings_text

tellraw @a[tag=enable_settings,tag=op] {"text":"[","color":"yellow","extra":[{"text":"!","color":"gold"},{"text":"] You have already been granted access to game settings."}]}
execute as @a[tag=enable_settings,tag=op] at @s run playsound minecraft:block.note_block.bass master @s ~ ~1 ~ 0.5 1.5
tag @a[tag=enable_settings,tag=op] remove enable_settings

tag @a[tag=enable_settings] add op
tellraw @a[tag=enable_settings] {"text":"[","color":"green","extra":[{"text":"!","color":"dark_green"},{"text":"] You may now update the game settings."}]}
execute as @a[tag=enable_settings] at @s run playsound minecraft:entity.player.levelup master @s ~ ~1 ~ 0.2 2
execute if score in_progress game_state matches 0 run clear @a[tag=enable_settings]
execute if score in_progress game_state matches 0 run tag @a[tag=enable_settings] add not_menu_click
clear @a[tag=enable_settings,team=lobby]
tag @a[tag=enable_settings,team=lobby] add not_menu_click
tag @a[tag=enable_settings] remove enable_settings


# Team emptier (failsafe for gamemode changes)

execute unless score gamemode game_state matches -1..2 as @a unless entity @s[team=!red,team=!blue] run tag @s add force_leave_team
execute if score gamemode game_state matches -1..2 run tag @a[team=pvp] add force_leave_team

execute as @a[tag=force_leave_team] at @s run playsound minecraft:block.note_block.bass master @s ~ ~1 ~ 0.4 0.7
execute as @a[tag=force_leave_team] at @s run playsound minecraft:item.shield.break master @s ~ ~1 ~ 0.3 0.5

tellraw @a[tag=force_leave_team,team=pvp] {"text":"[","color":"red","extra":[{"text":"!","color":"dark_red"},{"text":"] You were evicted from the queue "},{"text":"\"","color":"dark_gray"},{"text":"Players","color":"yellow"},{"text":"\"","color":"dark_gray"},{"text":" since the current gamemode requires multiple teams."}]}
tellraw @a[tag=force_leave_team,team=red] {"text":"[","color":"red","extra":[{"text":"!","color":"dark_red"},{"text":"] You were evicted from the queue "},{"text":"\"","color":"dark_gray"},{"text":"Red Team","color":"red"},{"text":"\"","color":"dark_gray"},{"text":" since the current gamemode does not support multiple teams."}]}
tellraw @a[tag=force_leave_team,team=blue] {"text":"[","color":"red","extra":[{"text":"!","color":"dark_red"},{"text":"] You were evicted from the queue "},{"text":"\"","color":"dark_gray"},{"text":"Blue Team","color":"blue"},{"text":"\"","color":"dark_gray"},{"text":" since the current gamemode does not support multiple teams."}]}

team join lobby @a[tag=force_leave_team]
tag @a[tag=force_leave_team] add not_menu_click
clear @a[tag=force_leave_team]
tag @a[tag=force_leave_team] remove force_leave_team


# Lobby Ready-Up System

scoreboard players set start_delay_seconds lobby_ready_state -1
scoreboard players operation start_delay_seconds lobby_ready_state += start_delay lobby_ready_state
scoreboard players operation start_delay_seconds lobby_ready_state /= ticks_per_second constants
scoreboard players add start_delay_seconds lobby_ready_state 1

execute if score in_progress game_state matches 1.. run scoreboard players set base_state lobby_ready_state 0
execute unless score in_progress game_state matches 1.. if score gamemode game_state matches -1..2 unless score red count matches 1.. run scoreboard players set base_state lobby_ready_state 1
execute unless score in_progress game_state matches 1.. if score gamemode game_state matches -1..2 unless score blue count matches 1.. run scoreboard players set base_state lobby_ready_state 1
execute unless score in_progress game_state matches 1.. unless score gamemode game_state matches -1..2 unless score players count matches 2.. run scoreboard players set base_state lobby_ready_state 1
execute unless score in_progress game_state matches 1.. if score gamemode game_state matches -1..2 if score red count matches 1.. if score blue count matches 1.. run scoreboard players set base_state lobby_ready_state 2
execute unless score in_progress game_state matches 1.. unless score gamemode game_state matches -1..2 if score players count matches 2.. run scoreboard players set base_state lobby_ready_state 2

execute if score base_state lobby_ready_state matches 2 if score start_delay lobby_ready_state matches 1.. run scoreboard players remove start_delay lobby_ready_state 1
execute if score base_state lobby_ready_state matches 2.. if score start_delay lobby_ready_state matches 101.. unless entity @a[team=!lobby,team=!spectator,team=!editor,tag=!ready] run scoreboard players set start_delay lobby_ready_state 100
execute if score base_state lobby_ready_state matches ..1 run scoreboard players set start_delay lobby_ready_state 1200


execute if score base_state lobby_ready_state matches ..0 run bossbar set minecraft:lobby value 0
execute if score base_state lobby_ready_state matches 1 run bossbar set minecraft:lobby value 1200
execute if score base_state lobby_ready_state matches 2.. store result bossbar minecraft:lobby value run scoreboard players get start_delay lobby_ready_state



execute if score base_state lobby_ready_state matches 0 run bossbar set minecraft:lobby name {"text":"Game in Progress...","color":"green"}

execute if score base_state lobby_ready_state matches 1 unless score players count matches 1.. run bossbar set minecraft:lobby name {"text":"Waiting for ","color":"gold","extra":[{"text":"2","color":"yellow"},{"text":" more players..."}]}
execute if score base_state lobby_ready_state matches 1 if score gamemode game_state matches -1..2 if score red count matches 0 if score blue count matches 1.. run bossbar set minecraft:lobby name {"text":"Waiting for players to join ","color":"gold","extra":[{"text":"Red Team","color":"red"},{"text":"..."}]}
execute if score base_state lobby_ready_state matches 1 if score gamemode game_state matches -1..2 if score red count matches 1.. if score blue count matches 0 run bossbar set minecraft:lobby name {"text":"Waiting for players to join ","color":"gold","extra":[{"text":"Blue Team","color":"blue"},{"text":"..."}]}
execute if score base_state lobby_ready_state matches 1 unless score gamemode game_state matches -1..2 if score players count matches 1 run bossbar set minecraft:lobby name {"text":"Waiting for ","color":"gold","extra":[{"text":"1","color":"yellow"},{"text":" more player..."}]}

execute if score base_state lobby_ready_state matches 2.. if score start_delay lobby_ready_state matches 101.. run bossbar set minecraft:lobby name {"text":"Match starting in ","color":"gold","extra":[{"score":{"name":"start_delay_seconds","objective":"lobby_ready_state"},"color":"yellow"},{"text":" seconds "},{"text":"(","color":"gray"},{"score":{"name":"ready","objective":"count"},"color":"green"},{"text":"/","color":"gray"},{"score":{"name":"players","objective":"count"},"color":"green"},{"text":" Ready","color":"dark_green"},{"text":")","color":"gray"}]}
execute if score base_state lobby_ready_state matches 2.. if score start_delay lobby_ready_state matches ..100 run bossbar set minecraft:lobby name {"text":"Match starting in ","color":"dark_purple","extra":[{"score":{"name":"start_delay_seconds","objective":"lobby_ready_state"},"color":"light_purple"},{"text":" seconds "},{"text":"(","color":"gray"},{"score":{"name":"ready","objective":"count"},"color":"green"},{"text":"/","color":"gray"},{"score":{"name":"players","objective":"count"},"color":"green"},{"text":" Ready","color":"dark_green"},{"text":")","color":"gray"}]}

execute if score base_state lobby_ready_state matches 2.. if score start_delay lobby_ready_state matches 100 as @a at @s run playsound minecraft:block.note_block.hat master @s ~ ~1 ~ 0.4 1
execute if score base_state lobby_ready_state matches 2.. if score start_delay lobby_ready_state matches 100 as @a at @s run playsound minecraft:block.portal.trigger master @s ~ ~1 ~ 0.3 0.77
execute if score base_state lobby_ready_state matches 2.. if score start_delay lobby_ready_state matches 100 as @a unless entity @s[team=!red,team=!pvp,team=!blue] run item replace entity @s inventory.4 with air
execute if score base_state lobby_ready_state matches 2.. if score start_delay lobby_ready_state matches ..100 as @a[tag=!ready] unless entity @s[team=!red,team=!pvp,team=!blue] run tag @s add ready
execute if score base_state lobby_ready_state matches 2.. if score start_delay lobby_ready_state matches 80 as @a at @s run playsound minecraft:block.note_block.hat master @s ~ ~1 ~ 0.4 1
execute if score base_state lobby_ready_state matches 2.. if score start_delay lobby_ready_state matches 60 as @a at @s run playsound minecraft:block.note_block.hat master @s ~ ~1 ~ 0.4 1
execute if score base_state lobby_ready_state matches 2.. if score start_delay lobby_ready_state matches 40 as @a at @s run playsound minecraft:block.note_block.hat master @s ~ ~1 ~ 0.4 1
execute if score base_state lobby_ready_state matches 2.. if score start_delay lobby_ready_state matches 20 as @a at @s run playsound minecraft:block.note_block.hat master @s ~ ~1 ~ 0.4 1

execute if score base_state lobby_ready_state matches ..1 unless score in_progress game_state matches 1.. run stopsound @a master minecraft:block.portal.trigger

execute if score in_progress game_state matches 1.. run bossbar set minecraft:lobby players @a[team=lobby]
execute unless score in_progress game_state matches 1.. run bossbar set minecraft:lobby players @a

execute if score in_progress game_state matches 1.. run bossbar set minecraft:game players @a[team=!lobby]
execute unless score in_progress game_state matches 1.. run bossbar set minecraft:game players none

execute if score in_progress game_state matches 1.. as @a[team=lobby] unless entity @s[scores={parkour_time=1..}] run title @s actionbar {"text":"Press ","color":"yellow","extra":[{"text":"[","color":"gold"},{"text":"E","color":"green"},{"text":"]","color":"gold"},{"text":" to open the Main Menu"}]}
execute unless score in_progress game_state matches 1.. as @a[team=!editor] unless entity @s[scores={parkour_time=1..}] run title @s actionbar {"text":"Press ","color":"yellow","extra":[{"text":"[","color":"gold"},{"text":"E","color":"green"},{"text":"]","color":"gold"},{"text":" to open the Main Menu"}]}

execute if score base_state lobby_ready_state matches 2 if score start_delay lobby_ready_state matches ..0 run function bow_game:game_setup

effect give @a[team=!lobby,scores={invisibility=1..}] invisibility 900000 0 true
effect clear @a[team=!lobby,scores={invisibility=1..}] glowing
execute as @a[team=!lobby] unless score @s invisibility matches 1.. run effect clear @s invisibility
scoreboard players remove @a[scores={invisibility=1..}] invisibility 1
scoreboard players reset @a[scores={invisibility=..0}] invisibility

execute as @a[team=lobby] at @s positioned ~ 30 ~ run tag @s[dx=0,dy=60,dz=0] add out_of_map
execute if score in_progress game_state matches 1.. as @a[team=!lobby,team=!editor] at @s positioned ~ -64 ~ run tag @s[dx=0,dy=60,dz=0] add out_of_map
execute unless score in_progress game_state matches 1.. as @a[team=!lobby,team=!editor] at @s positioned ~ 30 ~ run tag @s[dx=60,dy=60,dz=0] add out_of_map
tp @a[team=lobby,tag=out_of_map] 0 100 0 0 0
execute unless score in_progress game_state matches 1.. run tp @a[team=!lobby,tag=out_of_map] 0 100 0 0 0
execute as @a[team=lobby,tag=out_of_map] at @s run playsound minecraft:entity.enderman.teleport player @s ~ ~1 ~ 0.7 1.1
execute unless score in_progress game_state matches 1.. as @a[team=!lobby,tag=out_of_map] at @s run playsound minecraft:entity.enderman.teleport player @s ~ ~1 ~ 0.7 1.1
execute if score in_progress game_state matches 1.. run tp @a[team=!lobby,tag=out_of_map] @e[type=marker,tag=default_spawn,limit=1]
scoreboard players reset @a[tag=out_of_map] parkour_time
tag @a[tag=out_of_map] remove out_of_map


# Parkour stuff

particle firework -25 103.0 36 1 1 0 0 5
particle firework -25 103.0 36 1 1 0 0 1 force

scoreboard players remove parkour_gate sound_timer 1
execute if score parkour_gate sound_timer matches ..0 run playsound minecraft:block.beacon.ambient block @a -25 102 36 2 1.5
execute if score parkour_gate sound_timer matches ..0 run playsound minecraft:block.beacon.ambient block @a -25 102 36 1.8 2
execute if score parkour_gate sound_timer matches ..0 run scoreboard players set parkour_gate sound_timer 30

scoreboard players add @a[scores={parkour_time=1..}] parkour_time 1
execute positioned -2 98 12 as @a[dx=5,dy=5,dz=5,team=!editor] unless score @s fly_time matches 1.. unless score @s parkour_time matches 1.. run scoreboard players set @s parkour_time 1
execute positioned -3 98 3 run scoreboard players reset @a[dx=6,dy=5,dz=7,scores={parkour_time=1..}] parkour_time
execute as @a[scores={parkour_time=1}] at @s run playsound minecraft:entity.experience_orb.pickup master @s ~ ~1 ~ 0.4 1.4
scoreboard players set @a[scores={parkour_time=1}] parkour_block_count 0
execute as @a[scores={parkour_time=1..}] run scoreboard players operation @s parkour_milliseconds = @s parkour_time
execute as @a[scores={parkour_time=1..}] run scoreboard players operation @s parkour_milliseconds *= milliseconds_per_ticks constants
execute as @a[scores={parkour_time=1..}] run scoreboard players operation @s parkour_milliseconds %= milliseconds_per_seconds constants
execute as @a[scores={parkour_time=1..}] run scoreboard players operation @s parkour_seconds = @s parkour_time
execute as @a[scores={parkour_time=1..}] run scoreboard players operation @s parkour_seconds /= ticks_per_second constants
execute as @a[scores={parkour_time=1..}] run scoreboard players operation @s parkour_minutes = @s parkour_seconds
execute as @a[scores={parkour_time=1..}] run scoreboard players operation @s parkour_seconds %= seconds_per_minute constants
execute as @a[scores={parkour_time=1..}] run scoreboard players operation @s parkour_minutes /= seconds_per_minute constants

execute as @e[type=marker,tag=parkour_marker] at @s positioned ~-1 ~ ~-1 as @a[scores={parkour_time=1..},dx=2,dy=2,dz=2,nbt={OnGround:1b}] positioned ~1 ~ ~1 if score @s parkour_block_count < @e[type=marker,sort=nearest,limit=1,tag=parkour_marker] parkour_block_count at @s run playsound minecraft:ui.button.click master @s ~ ~ ~ 0.08 1.8
execute as @e[type=marker,tag=parkour_marker,scores={parkour_block_count=40}] at @s positioned ~-1 ~ ~-1 as @a[scores={parkour_time=1..},dx=2,dy=2,dz=2,nbt={OnGround:1b}] positioned ~1 ~ ~1 if score @s parkour_block_count < @e[type=marker,sort=nearest,limit=1,tag=parkour_marker] parkour_block_count at @s run playsound minecraft:entity.experience_orb.pickup master @s ~ ~ ~ 0.05 0.5
execute as @e[type=marker,tag=parkour_marker,scores={parkour_block_count=41}] at @s positioned ~-1 ~ ~-1 as @a[scores={parkour_time=1..},dx=2,dy=2,dz=2,nbt={OnGround:1b}] positioned ~1 ~ ~1 if score @s parkour_block_count < @e[type=marker,sort=nearest,limit=1,tag=parkour_marker] parkour_block_count at @s run playsound minecraft:entity.experience_orb.pickup master @s ~ ~ ~ 0.06 0.55
execute as @e[type=marker,tag=parkour_marker,scores={parkour_block_count=42}] at @s positioned ~-1 ~ ~-1 as @a[scores={parkour_time=1..},dx=2,dy=2,dz=2,nbt={OnGround:1b}] positioned ~1 ~ ~1 if score @s parkour_block_count < @e[type=marker,sort=nearest,limit=1,tag=parkour_marker] parkour_block_count at @s run playsound minecraft:entity.experience_orb.pickup master @s ~ ~ ~ 0.07 0.6
execute as @e[type=marker,tag=parkour_marker,scores={parkour_block_count=43}] at @s positioned ~-1 ~ ~-1 as @a[scores={parkour_time=1..},dx=2,dy=2,dz=2,nbt={OnGround:1b}] positioned ~1 ~ ~1 if score @s parkour_block_count < @e[type=marker,sort=nearest,limit=1,tag=parkour_marker] parkour_block_count at @s run playsound minecraft:entity.experience_orb.pickup master @s ~ ~ ~ 0.08 0.65
execute as @e[type=marker,tag=parkour_marker,scores={parkour_block_count=44}] at @s positioned ~-1 ~ ~-1 as @a[scores={parkour_time=1..},dx=2,dy=2,dz=2,nbt={OnGround:1b}] positioned ~1 ~ ~1 if score @s parkour_block_count < @e[type=marker,sort=nearest,limit=1,tag=parkour_marker] parkour_block_count at @s run playsound minecraft:entity.experience_orb.pickup master @s ~ ~ ~ 0.09 0.7
execute as @e[type=marker,tag=parkour_marker,scores={parkour_block_count=45}] at @s positioned ~-1 ~ ~-1 as @a[scores={parkour_time=1..},dx=2,dy=2,dz=2,nbt={OnGround:1b}] positioned ~1 ~ ~1 if score @s parkour_block_count < @e[type=marker,sort=nearest,limit=1,tag=parkour_marker] parkour_block_count at @s run playsound minecraft:entity.experience_orb.pickup master @s ~ ~ ~ 0.10 0.75
execute as @e[type=marker,tag=parkour_marker,scores={parkour_block_count=46}] at @s positioned ~-1 ~ ~-1 as @a[scores={parkour_time=1..},dx=2,dy=2,dz=2,nbt={OnGround:1b}] positioned ~1 ~ ~1 if score @s parkour_block_count < @e[type=marker,sort=nearest,limit=1,tag=parkour_marker] parkour_block_count at @s run playsound minecraft:entity.experience_orb.pickup master @s ~ ~ ~ 0.11 0.8
execute as @e[type=marker,tag=parkour_marker,scores={parkour_block_count=47}] at @s positioned ~-1 ~ ~-1 as @a[scores={parkour_time=1..},dx=2,dy=2,dz=2,nbt={OnGround:1b}] positioned ~1 ~ ~1 if score @s parkour_block_count < @e[type=marker,sort=nearest,limit=1,tag=parkour_marker] parkour_block_count at @s run playsound minecraft:entity.experience_orb.pickup master @s ~ ~ ~ 0.12 0.85
execute as @e[type=marker,tag=parkour_marker,scores={parkour_block_count=48}] at @s positioned ~-1 ~ ~-1 as @a[scores={parkour_time=1..},dx=2,dy=2,dz=2,nbt={OnGround:1b}] positioned ~1 ~ ~1 if score @s parkour_block_count < @e[type=marker,sort=nearest,limit=1,tag=parkour_marker] parkour_block_count at @s run playsound minecraft:entity.experience_orb.pickup master @s ~ ~ ~ 0.13 0.9
execute as @e[type=marker,tag=parkour_marker,scores={parkour_block_count=49}] at @s positioned ~-1 ~ ~-1 as @a[scores={parkour_time=1..},dx=2,dy=2,dz=2,nbt={OnGround:1b}] positioned ~1 ~ ~1 if score @s parkour_block_count < @e[type=marker,sort=nearest,limit=1,tag=parkour_marker] parkour_block_count at @s run playsound minecraft:entity.experience_orb.pickup master @s ~ ~ ~ 0.14 0.95
execute as @e[type=marker,tag=parkour_marker] at @s positioned ~-1 ~ ~-1 as @a[scores={parkour_time=1..},dx=2,dy=2,dz=2,nbt={OnGround:1b}] positioned ~1 ~ ~1 run scoreboard players operation @s parkour_block_count = @e[type=marker,sort=nearest,limit=1,tag=parkour_marker] parkour_block_count

execute as @a[scores={parkour_time=1..,parkour_block_count=..9}] unless score @s parkour_seconds matches 10.. if score @s parkour_milliseconds matches 10.. run title @s actionbar {"text":"","color":"yellow","extra":[{"text":"Time","color":"green"},{"text":": ","color":"gold"},{"score":{"name":"@s","objective":"parkour_minutes"},"bold":"true"},{"text":":","color":"gold"},{"text":"0","bold":"true"},{"score":{"name":"@s","objective":"parkour_seconds"},"bold":"true"},{"text":".","color":"gold"},{"score":{"name":"@s","objective":"parkour_milliseconds"},"bold":"true"},{"text":" - ","color":"gray"},{"text":"Block: ","color":"gold"},{"text":"0","bold":"true"},{"score":{"name":"@s","objective":"parkour_block_count"},"bold":"true"},{"text":"/","color":"gold"},{"text":"50"}]}
execute as @a[scores={parkour_time=1..,parkour_block_count=..9}] if score @s parkour_seconds matches 10.. if score @s parkour_milliseconds matches 10.. run title @s actionbar {"text":"","color":"yellow","extra":[{"text":"Time","color":"green"},{"text":": ","color":"gold"},{"score":{"name":"@s","objective":"parkour_minutes"},"bold":"true"},{"text":":","color":"gold"},{"score":{"name":"@s","objective":"parkour_seconds"},"bold":"true"},{"text":".","color":"gold"},{"score":{"name":"@s","objective":"parkour_milliseconds"},"bold":"true"},{"text":" - ","color":"gray"},{"text":"Block: ","color":"gold"},{"text":"0","bold":"true"},{"score":{"name":"@s","objective":"parkour_block_count"},"bold":"true"},{"text":"/","color":"gold"},{"text":"50"}]}
execute as @a[scores={parkour_time=1..,parkour_block_count=..9}] unless score @s parkour_seconds matches 10.. unless score @s parkour_milliseconds matches 10.. run title @s actionbar {"text":"","color":"yellow","extra":[{"text":"Time","color":"green"},{"text":": ","color":"gold"},{"score":{"name":"@s","objective":"parkour_minutes"},"bold":"true"},{"text":":","color":"gold"},{"text":"0","bold":"true"},{"score":{"name":"@s","objective":"parkour_seconds"},"bold":"true"},{"text":".","color":"gold"},{"text":"0","bold":"true"},{"score":{"name":"@s","objective":"parkour_milliseconds"},"bold":"true"},{"text":" - ","color":"gray"},{"text":"Block: ","color":"gold"},{"text":"0","bold":"true"},{"score":{"name":"@s","objective":"parkour_block_count"},"bold":"true"},{"text":"/","color":"gold"},{"text":"50"}]}
execute as @a[scores={parkour_time=1..,parkour_block_count=..9}] if score @s parkour_seconds matches 10.. unless score @s parkour_milliseconds matches 10.. run title @s actionbar {"text":"","color":"yellow","extra":[{"text":"Time","color":"green"},{"text":": ","color":"gold"},{"score":{"name":"@s","objective":"parkour_minutes"},"bold":"true"},{"text":":","color":"gold"},{"score":{"name":"@s","objective":"parkour_seconds"},"bold":"true"},{"text":".","color":"gold"},{"text":"0","bold":"true"},{"score":{"name":"@s","objective":"parkour_milliseconds"},"bold":"true"},{"text":" - ","color":"gray"},{"text":"Block: ","color":"gold"},{"text":"0","bold":"true"},{"score":{"name":"@s","objective":"parkour_block_count"},"bold":"true"},{"text":"/","color":"gold"},{"text":"50"}]}

execute as @a[scores={parkour_time=1..,parkour_block_count=10..39}] unless score @s parkour_seconds matches 10.. if score @s parkour_milliseconds matches 10.. run title @s actionbar {"text":"","color":"yellow","extra":[{"text":"Time","color":"green"},{"text":": ","color":"gold"},{"score":{"name":"@s","objective":"parkour_minutes"},"bold":"true"},{"text":":","color":"gold"},{"text":"0","bold":"true"},{"score":{"name":"@s","objective":"parkour_seconds"},"bold":"true"},{"text":".","color":"gold"},{"score":{"name":"@s","objective":"parkour_milliseconds"},"bold":"true"},{"text":" - ","color":"gray"},{"text":"Block: ","color":"gold"},{"score":{"name":"@s","objective":"parkour_block_count"},"bold":"true"},{"text":"/","color":"gold"},{"text":"50"}]}
execute as @a[scores={parkour_time=1..,parkour_block_count=10..39}] if score @s parkour_seconds matches 10.. if score @s parkour_milliseconds matches 10.. run title @s actionbar {"text":"","color":"yellow","extra":[{"text":"Time","color":"green"},{"text":": ","color":"gold"},{"score":{"name":"@s","objective":"parkour_minutes"},"bold":"true"},{"text":":","color":"gold"},{"score":{"name":"@s","objective":"parkour_seconds"},"bold":"true"},{"text":".","color":"gold"},{"score":{"name":"@s","objective":"parkour_milliseconds"},"bold":"true"},{"text":" - ","color":"gray"},{"text":"Block: ","color":"gold"},{"score":{"name":"@s","objective":"parkour_block_count"},"bold":"true"},{"text":"/","color":"gold"},{"text":"50"}]}
execute as @a[scores={parkour_time=1..,parkour_block_count=10..39}] unless score @s parkour_seconds matches 10.. unless score @s parkour_milliseconds matches 10.. run title @s actionbar {"text":"","color":"yellow","extra":[{"text":"Time","color":"green"},{"text":": ","color":"gold"},{"score":{"name":"@s","objective":"parkour_minutes"},"bold":"true"},{"text":":","color":"gold"},{"text":"0","bold":"true"},{"score":{"name":"@s","objective":"parkour_seconds"},"bold":"true"},{"text":".","color":"gold"},{"text":"0","bold":"true"},{"score":{"name":"@s","objective":"parkour_milliseconds"},"bold":"true"},{"text":" - ","color":"gray"},{"text":"Block: ","color":"gold"},{"score":{"name":"@s","objective":"parkour_block_count"},"bold":"true"},{"text":"/","color":"gold"},{"text":"50"}]}
execute as @a[scores={parkour_time=1..,parkour_block_count=10..39}] if score @s parkour_seconds matches 10.. unless score @s parkour_milliseconds matches 10.. run title @s actionbar {"text":"","color":"yellow","extra":[{"text":"Time","color":"green"},{"text":": ","color":"gold"},{"score":{"name":"@s","objective":"parkour_minutes"},"bold":"true"},{"text":":","color":"gold"},{"score":{"name":"@s","objective":"parkour_seconds"},"bold":"true"},{"text":".","color":"gold"},{"text":"0","bold":"true"},{"score":{"name":"@s","objective":"parkour_milliseconds"},"bold":"true"},{"text":" - ","color":"gray"},{"text":"Block: ","color":"gold"},{"score":{"name":"@s","objective":"parkour_block_count"},"bold":"true"},{"text":"/","color":"gold"},{"text":"50"}]}

execute as @a[scores={parkour_time=1..,parkour_block_count=40..}] unless score @s parkour_seconds matches 10.. if score @s parkour_milliseconds matches 10.. run title @s actionbar {"text":"","color":"yellow","extra":[{"text":"Time","color":"green"},{"text":": ","color":"gold"},{"score":{"name":"@s","objective":"parkour_minutes"},"bold":"true"},{"text":":","color":"gold"},{"text":"0","bold":"true"},{"score":{"name":"@s","objective":"parkour_seconds"},"bold":"true"},{"text":".","color":"gold"},{"score":{"name":"@s","objective":"parkour_milliseconds"},"bold":"true"},{"text":" - ","color":"gray"},{"text":"Block: ","color":"gold"},{"score":{"name":"@s","objective":"parkour_block_count"},"bold":"true","color":"green"},{"text":"/","color":"gold"},{"text":"50"}]}
execute as @a[scores={parkour_time=1..,parkour_block_count=40..}] if score @s parkour_seconds matches 10.. if score @s parkour_milliseconds matches 10.. run title @s actionbar {"text":"","color":"yellow","extra":[{"text":"Time","color":"green"},{"text":": ","color":"gold"},{"score":{"name":"@s","objective":"parkour_minutes"},"bold":"true"},{"text":":","color":"gold"},{"score":{"name":"@s","objective":"parkour_seconds"},"bold":"true"},{"text":".","color":"gold"},{"score":{"name":"@s","objective":"parkour_milliseconds"},"bold":"true"},{"text":" - ","color":"gray"},{"text":"Block: ","color":"gold"},{"score":{"name":"@s","objective":"parkour_block_count"},"bold":"true","color":"green"},{"text":"/","color":"gold"},{"text":"50"}]}
execute as @a[scores={parkour_time=1..,parkour_block_count=40..}] unless score @s parkour_seconds matches 10.. unless score @s parkour_milliseconds matches 10.. run title @s actionbar {"text":"","color":"yellow","extra":[{"text":"Time","color":"green"},{"text":": ","color":"gold"},{"score":{"name":"@s","objective":"parkour_minutes"},"bold":"true"},{"text":":","color":"gold"},{"text":"0","bold":"true"},{"score":{"name":"@s","objective":"parkour_seconds"},"bold":"true"},{"text":".","color":"gold"},{"text":"0","bold":"true"},{"score":{"name":"@s","objective":"parkour_milliseconds"},"bold":"true"},{"text":" - ","color":"gray"},{"text":"Block: ","color":"gold"},{"score":{"name":"@s","objective":"parkour_block_count"},"bold":"true","color":"green"},{"text":"/","color":"gold"},{"text":"50"}]}
execute as @a[scores={parkour_time=1..,parkour_block_count=40..}] if score @s parkour_seconds matches 10.. unless score @s parkour_milliseconds matches 10.. run title @s actionbar {"text":"","color":"yellow","extra":[{"text":"Time","color":"green"},{"text":": ","color":"gold"},{"score":{"name":"@s","objective":"parkour_minutes"},"bold":"true"},{"text":":","color":"gold"},{"score":{"name":"@s","objective":"parkour_seconds"},"bold":"true"},{"text":".","color":"gold"},{"text":"0","bold":"true"},{"score":{"name":"@s","objective":"parkour_milliseconds"},"bold":"true"},{"text":" - ","color":"gray"},{"text":"Block: ","color":"gold"},{"score":{"name":"@s","objective":"parkour_block_count"},"bold":"true","color":"green"},{"text":"/","color":"gold"},{"text":"50"}]}

execute positioned -27 100 36 run scoreboard players set @a[dx=3,dy=3,dz=0,scores={parkour_time=1..}] fly_time 10
execute if entity @a[scores={fly_time=10}] run function bow_game:parkour_winner

scoreboard players remove @a[scores={fly_time=1},nbt={OnGround:1b}] fly_time 1
scoreboard players remove @a[scores={fly_time=2..}] fly_time 1
effect give @a[scores={fly_time=2..8}] minecraft:levitation 900000 127 true
effect clear @a[scores={fly_time=..1}] minecraft:levitation
effect give @a[scores={fly_time=1..8}] minecraft:slow_falling 900000 0 true
effect clear @a[scores={fly_time=..0}] minecraft:slow_falling
scoreboard players reset @a[scores={fly_time=..0}] fly_time
execute as @a[scores={fly_time=1..8}] at @s run particle cloud ~ ~-1 ~ 0.3 0 0.3 0 8

execute as @e[type=armor_stand,tag=gold_spin] at @s run tp @s ~ ~ ~ ~2 ~
execute as @e[type=armor_stand,tag=gold_spin] at @s run particle minecraft:composter ~ ~0.9 ~ 0.15 0.15 0.15 0 1

# Trident Gamemode Unlock

scoreboard players add @e[type=item,tag=new_gamemode] sound_timer 1
scoreboard players set @e[type=item,tag=new_gamemode,scores={sound_timer=3..}] sound_timer 0
execute as @e[type=item,tag=new_gamemode] if score @s sound_timer matches 0 positioned -2 95 -8 as @a[dx=4,dy=2,dz=7] at @s run playsound minecraft:ambient.warped_forest.additions ambient @s ~ ~1 ~ 0.5 0.5
execute if entity @e[type=item,tag=new_gamemode] positioned -2 95 -8 run effect give @a[dx=4,dy=2,dz=7] minecraft:slowness 1 5 true
execute if entity @e[type=item,tag=new_gamemode] positioned -2 95 -8 run effect give @a[dx=4,dy=2,dz=7] minecraft:blindness 2 0 true
execute if entity @e[type=item,tag=new_gamemode] positioned -2 95 -8 run effect give @a[dx=4,dy=2,dz=7] minecraft:levitation 1 128 true
execute if entity @e[type=item,tag=new_gamemode] run particle minecraft:large_smoke 0 96 -6 1 0.5 1 0 2
execute if entity @e[type=item,tag=new_gamemode] run particle minecraft:large_smoke 0 96 -7.5 0.5 0.7 0.2 0 10 force

execute as @a[nbt={Inventory:[{id:"minecraft:trident",tag:{Gamemode:1b}}]}] at @s run playsound minecraft:entity.zombie_villager.cure player @a ~ ~1 ~ 0.3 0.7
execute as @a[nbt={Inventory:[{id:"minecraft:trident",tag:{Gamemode:1b}}]}] at @s positioned ^ ^ ^1 run particle flash ~ ~1 ~ 0 0 0 0 1 force
execute if entity @a[nbt={Inventory:[{id:"minecraft:trident",tag:{Gamemode:1b}}]}] run function bow_game:unlock_trident_gamemode
clear @a[nbt={Inventory:[{id:"minecraft:trident",tag:{Gamemode:1b}}]}] minecraft:trident{Gamemode:1b}

execute if score in_progress game_state matches 1.. run item replace entity @a[team=!lobby,team=!editor,team=!spectator] inventory.13 with dark_oak_door{display:{Name:'{"text":"Leave Game","color":"red","italic":"false"}',Lore:['{"text":"(Left Click)","color":"dark_gray","italic":"false"}']}}
execute if score in_progress game_state matches 1.. run item replace entity @a[team=spectator] inventory.13 with dark_oak_door{display:{Name:'{"text":"To return to lobby, simply","color":"gray"}',Lore:['{"text":"fly away from the arena.","color":"gray"}']}}

execute if score donate_text time matches 204.. run tellraw @a {"text":"\n[","color":"gold","extra":[{"text":"!","color":"yellow"},{"text":"] Enjoying "},{"text":"PROJECT ","bold":"true","color":"white"},{"text":"TARIUS","color":"yellow","bold":"true"},{"text":"? Consider "},{"text":"Donating","color":"light_purple"},{"text":" to help support future projects by "},{"text":"CanadianHybrid","color":"yellow"},{"text":"!"}]}
execute if score donate_text time matches 204.. run tellraw @a {"text":"\n[","bold":"true","color":"dark_aqua","bold":"true","extra":[{"text":"> ","color":"aqua"},{"text":"Click Here to Donate","underlined":"true","color":"green","clickEvent":{"action":"open_url","value":"https://www.paypal.com/donate/?hosted_button_id=6GTK8HVAP4DAN"},"hoverEvent":{"action":"show_text","contents":[{"text":"Donate via ","color":"yellow","extra":[{"text":"PayPal","color":"green"}]}]}},{"text":" <","color":"aqua"},{"text":"]\n"}]}
execute if score donate_text time matches 204.. as @a at @s run playsound minecraft:block.note_block.harp master @s ~ ~1 ~ 0.4 2
execute if score donate_text time matches 204.. as @a at @s run playsound minecraft:block.note_block.harp master @s ~ ~1 ~ 0.4 1.5
execute if score donate_text time matches 204.. run scoreboard players reset donate_text time
execute if score donate_text time matches 1.. run scoreboard players add donate_text time 1

execute if entity @a if score need_lobby_respawn game_state matches 1.. run function bow_game:respawn_lobby_entites
execute if entity @a if score need_lobby_respawn game_state matches 1.. run scoreboard players reset need_lobby_respawn game_state

stopsound @a player item.armor.equip_leather
